# include <cstdlib>
# include <cstdio>
# include <iostream>
# include <fstream>
# include <string.h>
# include "mat-lib.h"

using namespace std;


void leggi_mat(int mat[][MAX_C], int &rig, int &col)
{
  unsigned scelta=0;
  int i,j;
  char appo[100], nome[50];
  char c;
  fstream f;
  
  system("cls");
  cout << "\nLettura matrice\n";
  cout << "\t 1 - Lettura da tastiera\n";
  cout << "\t 2 - Lettura da file\n";
  do
  {
      system("cls");
      cout << "\nLettura matrice\n";
      cout << "\t 1 - Lettura da tastiera\n";
      cout << "\t 2 - Lettura da file\n";
      cout << "\rScelta = ";
      cin >> scelta;
      if( !cin.good() )
      {
        cout << "\nerrore in lettura \n";
        cin.clear(ios::goodbit);
        cin.getline(appo,100);
      } 
  } while ( (scelta<1)||(scelta>2) );
  
  if(scelta==1)
  {
      cout << "Inserisci le dimensioni della matrice\n";
      cin >> rig >> col;
      cout << "Inserisci gli elementi della matrice\n";
      for(i=0;i<rig;i++)
         for(j=0;j<col;j++)
            cin >> mat[i][j];
  }
  else
  {
      cout << "lettura da file\n";
      cout << "immetti il nome del file\n";
      cin >> nome;
      cout << "il nome del file e': " << nome << endl;
      cout << "premi un tasto per continuare\n";
      cin >> c;
      f.open(nome, ios::in);
      if(!f)
      {
          cout << "Errore nell'apertura del file dati.txt \n";
          exit(1);
      }
      else
      {
          f >> rig >> col;
          for(i=0;i<rig;i++)
              for(j=0;j<col;j++)
                  f >> mat[i][j];  
      }
  }
}


void stampa_mat(int mat[][MAX_C], int rig, int col)
{
  unsigned scelta=0;
  int i,j;
  char appo[100], nome[50];
  fstream f;
  char c;
  
  system("cls");
  cout << "\nScrittura matrice\n";
  cout << "\t 1 - scrittura a video\n";
  cout << "\t 2 - scrittura su file\n";
  do
  {
      system("cls");
      cout << "\nScrittura matrice\n";
      cout << "\t 1 - scrittura a video\n";
      cout << "\t 2 - scrittura su file\n";
      cout << "\rScelta = ";
      cin >> scelta;
      if( !cin.good() )
      {
        cout << "\nerrore in lettura \n";
        cin.clear(ios::goodbit);
        cin.getline(appo,100);
      } 
   } while ( (scelta<1)||(scelta>2) );
  
   if(scelta==1)
   {
      cout << "la matrice e': \n";
      for(i=0;i<rig;i++)
      {
          for(j=0;j<col;j++)
              cout << mat[i][j] << " ";
          cout << endl;  
      }
      cout << endl;
      cout << "premi un tasto per continuare\n";
      cin >> c;
   }
   else
   {
      cout << "scrittura su file\n";
      cout << "immetti il nome del file\n";
      cin >> nome;
      cout << "il nome del file e': " << nome << endl;
      cout << "premi un tasto per continuare\n";
      cin >> c;      
      f.open(nome, ios::out|ios::app);
      if(!f)
      {
          cout << "Errore nell'apertura del file dati_out.txt \n";
          exit(1);
      }
      else
      {
          for(i=0;i<rig;i++)
          {
              for(j=0;j<col;j++)
                  f << mat[i][j] << " ";
              f << endl;  
          }
          f << endl;  
      }
   }
}

void stampa_vet(int v[], int r)
{
    cout << "il vettore e': " << endl;
      
    for(int i=0; i<r; i++)
        cout << "v[" << i << "]= " << v[i] << endl; 
}

void calcola_max(int v[], int r, int& max, int& p)
{
    int j;
    
    if(r==0)
    {
        cout << "vettore nullo" << endl;
        max=0;
        p=-1;
    }
    else
    {
        max=v[0];
        p=0;
        for(j=1;j<r;j++)
            if(v[j]>max)
            {
                max=v[j];
                p=j;
            }              
    }
}

void  calcola_min(int v[], int r, int& min, int& p, int ei)
{
    if(r-ei>0)
    {
        p=ei;
        min=v[ei];
    }
    else
    {
        cout << "vettore nullo" << endl;
        p=-1;
        min=0;
    }
    for(int i=ei+1; i<r; i++)
        if(v[i]<min)
        {
            min=v[i];
            p=i;
        }
}

void swap(int v[], int a, int b)
{
    int appo;
 
    appo=v[a];
    v[a]=v[b];
    v[b]=appo;
}

void swap(int mat[][MAX_C], int r1, int r2, int c)
{
    int appo;
    for(int j=0;j<c;j++)
    {
        appo=mat[r1][j];
        mat[r1][j]=mat[r2][j];
        mat[r2][j]=appo;
    }
}

void mat_select_sort(int mat[][MAX_C], int r, int c, int v[])
{
    int min, pos;
    for(int i=0; i<r-1; i++)
    {
        calcola_min(v, r, min, pos, i);
        if(i != pos)
        {
            swap(v,i,pos);
            swap(mat,i,pos,c);
        }      
    }
}


